Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -57,5 +612,5 @@
 
     if ( ((_get_mmu_mode() & 0x4) == 0 ) || USE_IOC_RDK )  // identity
-    {
+    { 
         buf_paddr = (unsigned long long)buf_vaddr;
     }
@@ -65,13 +620,9 @@
     }
 
-#if GIET_DEBUG_FAT 
-unsigned int procid  = _get_procid();
-unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
-unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
-unsigned int p       = procid & ((1<<P_WIDTH)-1);
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] P[%d,%d,%d] enters _fat_ioc_access() at cycle %d\n"
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _fat_ioc_access() : enters at cycle %d\n"
         "  to_mem = %d / vaddr = %x / paddr = %l / sectors = %d / lba = %x\n",
-        x, y , p, _get_proctime(), to_mem, buf_vaddr, buf_paddr, count, lba );
+        _get_proctime(), to_mem, buf_vaddr, buf_paddr, count, lba );
 #endif
 
@@ -100,230 +651,55 @@
 
 
-//////////////////////////////////////////////////////////////////////////////////
-// This function displays the content of the FAT cache
-//////////////////////////////////////////////////////////////////////////////////
-#if GIET_DEBUG_FAT 
-static
-void _display_fat_cache()
-{
-    unsigned int line;
-    unsigned int word;
-    unsigned int temp[9];
-
-    temp[8] = 0;
-
-    _puts("\n*********************** fat_cache_lba = ");
-    _putx( _fat.cache_lba );
-    _puts(" *****************************\n");
-
-    for ( line = 0 ; line < 16 ; line++ )
-    {
-        // display line index 
-        _putx( line );
-        _puts(" : ");
-
-        // display 8*4 bytes hexa
-        for ( word=0 ; word<8 ; word++ )
-        {
-            unsigned int byte  = (line<<5) + (word<<2);
-            unsigned int hexa  = (_fat.fat_cache[byte  ]<<24) |
-                                 (_fat.fat_cache[byte+1]<<16) |
-                                 (_fat.fat_cache[byte+2]<< 8) |
-                                 (_fat.fat_cache[byte+3]);
-            _putx( hexa );
-            _puts(" | ");
-
-            // prepare display ascii
-            temp[word] = _fat.fat_cache[byte]         |
-                         (_fat.fat_cache[byte+1]<<8)  |
-                         (_fat.fat_cache[byte+2]<<16) |
-                         (_fat.fat_cache[byte+3]<<24) ;
-        }
-        
-        // display data ascii 
-        _puts( (char*)temp );
-        _puts("\n");
-    }
-    _puts("***************************************************************************\n");
-
-} // end _display_fat_cache()  
-#endif
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function displays the FAT descriptor.
-//////////////////////////////////////////////////////////////////////////////////
-#if GIET_DEBUG_FAT
-static
-void _fat_print()
-{
-    _printf("\n########################## FAT32 ################################"  
-            "\nFAT initialised                  %x"
-            "\nSector Size  (bytes)             %x"
-            "\nSectors per cluster              %x"
-            "\nFAT region first lba             %x"
-            "\nData region first lba            %x"
-            "\nNumber of sectors for one FAT    %x"
-            "\nNumber of free clusters          %x"
-            "\nLast allocated cluster           %x" 
-            "\n#################################################################\n",
-            _fat.initialised,
-            _fat.sector_size,
-            _fat.sectors_per_cluster,
-            _fat.fat_lba,
-            _fat.data_lba,
-            _fat.fat_sectors,
-            _fat.number_free_cluster,
-            _fat.last_cluster_allocated );
-} // end _fat_print()
-#endif
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function returns the length of a FAT field. This field is identified
-// by an (offset,length) mnemonic defined in fat32.h file.
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-int get_length( int offset, 
-                int length )
-{
-    return length;
+
+
+/////////////////////////////////////////////////////////////////////
+static inline unsigned int _get_levels_from_size( unsigned int size )
+{ 
+    if      ( size <= (1<<18) ) return 1;     // 64 clusters == 256 Kbytes
+    else if ( size <= (1<<24) ) return 2;     // 64 * 64 clusters => 16 Mbytes
+    else if ( size <= (1<<30) ) return 3;     // 64 * 64 * 64 cluster => 1 Gbytes
+    else                        return 4;     // 64 * 64 * 64 * 64 clusters 
 }
 
-//////////////////////////////////////////////////////////////////////////////
-// Write one 32 bits word "value" in a char[] buffer. 
-// The modified field in buffer is defined by the offset and size arguments.
-//////////////////////////////////////////////////////////////////////////////
-static 
-void _write_entry( unsigned int   offset,
-                   unsigned int   size,
-                   char*          buffer,
-                   unsigned int   value )
-{
-    unsigned int turn = 0;
-    unsigned int res  = value;
-    unsigned int mask = 0x000000ff;
-
-    while( turn != size - 1 )
-    {
-        buffer[ offset + turn ] = res & mask;
-        res = res >> 8;
-        turn++;
-    }
-    buffer[offset + turn] = res & mask;
+
+
+////////////////////////////////////////////////////////
+static unsigned int _read_entry( unsigned int    offset,
+                                 unsigned int    size,
+                                 unsigned char*  buffer,
+                                 unsigned int    little_endian )
+{
+    unsigned int n;
+    unsigned int res  = 0;
+
+    if ( little_endian)
+    {
+        for( n = size ; n > 0 ; n-- ) res = (res<<8) | buffer[offset+n-1];
+    }
+    else
+    {
+        for( n = 0 ; n < size ; n++ ) res = (res<<8) | buffer[offset+n];
+    }
+    return res;
+
+}  // end _read_entry
+
+
+
+//////////////////////////////////////////////////////////////////
+static inline unsigned int _cluster_to_lba( unsigned int cluster )       
+{
+    if ( cluster < 2 )
+    { 
+        _printf("\n[FAT ERROR] in _cluster_to_lba() cluster smaller than 2\n"); 
+        _exit();
+    }
+
+   return  ((cluster - 2) << 3) + _fat.data_lba;
 }
 
-//////////////////////////////////////////////////////////////////////////////
-// Read one 32 bits word in a char[] buffer, taking endianness into account. 
-// The analysed field in buffer is defined by the offset and size arguments.
-//////////////////////////////////////////////////////////////////////////////
-static 
-unsigned int _read_entry( unsigned int   offset,
-                          unsigned int   size,
-                          char*          buffer,
-                          unsigned int   little_indian )
-{
-    unsigned int turn;
-    unsigned int res  = 0;
-    unsigned int mask = 0x000000ff;
-
-    if( little_indian )
-    {
-        turn = size;
-        while( turn != 1 )
-        {
-            res = res | (buffer[offset + (turn-1)] & mask);
-            res = res << 8;
-            turn--;
-        }
-        res = (buffer[offset + (turn-1)] & mask) | res;
-    }
-    else
-    {
-        turn = 0;
-        while( turn != size - 1 )
-        {
-
-            res = res  | (buffer[ offset + turn ] & mask );
-            res = res << 8;
-            turn++;
-        }
-        res = res | (buffer[offset + turn] & mask);
-    }
-    return res;
-}
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function retuns the cluster index from the lba of a DATA sector.
-// The lba must be larger than the lba of the first DATA sector.
-// The DATA region indexing starts a cluster 2.
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-unsigned int lba_to_cluster( unsigned int lba )                   
-{
-   if (lba < _fat.data_lba ) return 0;
-
-   return ( (lba - _fat.data_lba) / _fat.sectors_per_cluster) + 2; 
-}
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function retuns the lba of first sector in DATA region 
-// from the cluster index. The cluster index must be larger than 2. 
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-unsigned int cluster_to_lba( unsigned int cluster )       
-{
-   if ( cluster < 2 ) return 0; 
-
-   return  (_fat.sectors_per_cluster * (cluster - 2)) + _fat.data_lba;
-}
-
-///////////////////////////////////////////////////////////////////////////////// 
-// This function search the FAT (using the FAT cache), and returns 
-// the next cluster index from the current cluster index in the FAT.
-// remark: a sector of FAT contains 128 cluster indexes.
-/////////////////////////////////////////////////////////////////////////////////
-static 
-unsigned int _get_next_cluster( unsigned int use_irq,
-                                unsigned int cluster )
-{
-    // compute lba of the sector containing the cluster index
-    unsigned int lba = _fat.fat_lba + (cluster / 128);
-
-    if ( lba != _fat.cache_lba )      // miss in fat_cache
-    {
-        // access fat
-        if( _fat_ioc_access( use_irq,
-                             1,               // read
-                             lba, 
-                             (unsigned int)_fat.fat_cache,
-                             1 ) )            // one sector
-        {
-            _printf("[FAT_ERROR] in get_next_cluster_id() : cannot read block %x", 
-                    lba );
-            return 1;
-        }
-        _fat.cache_lba = lba;
-    }
-
-    unsigned int next = _read_entry( ((cluster % 128) * 4), 
-                                     4, 
-                                     _fat.fat_cache,
-                                     1 );
-#if GIET_DEBUG_FAT 
-unsigned int procid  = _get_procid();
-unsigned int x       = procid >> (Y_WIDTH + P_WIDTH);
-unsigned int y       = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
-unsigned int p       = procid & ((1<<P_WIDTH)-1);
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] P[%d,%d,%d] in _get_next_cluster() :  next = %x\n",
-        x , y , p , next );
-if ( (_get_proctime() > GIET_DEBUG_FAT) && (GIET_DEBUG_FAT & 0x1) )
-_display_fat_cache();
-#endif
-
-    return next;
-}
 
 //////////////////////////////////////////////////////
-static inline unsigned char to_upper(unsigned char c)
+static inline unsigned char _to_upper(unsigned char c)
 {
    if (c >= 'a' && c <= 'z') return (c & ~(0x20));
@@ -331,137 +707,54 @@
 }
 
-////////////////////////////////////////////////////////////////
-// This function is a filter:
-// Return the c character if c is a legal short name character
-// Return the '_' character if c is illegal
-////////////////////////////////////////////////////////////////
-static 
-unsigned char illegal_short(unsigned char c)
-{
-   const unsigned char illegal_char [] =";+=[]â,\"*\\<>/?:|\0";
-   short i = 0;
-   while (illegal_char[i]!='\0')
-   {
-      if (c == illegal_char[i])
-         return '_';
-      i++;
-   }
-   return c;
-}
-
-/////////////////////////////////////////////////////////////////////////////////
-// This function test if the string argument is a legal SFN (Short File Name)
-// and copies this name (removing the .) in the sfn_string argument.
-// Criteria for a Short File Name are:
-// - separator is '.' (extension is not mandatory)
-// - 1 <= name length <= 8
-// - 0 <= extension length <= 3
-// - no illegal character (see illega_short() function)
-// Return 1 if it string is a legal SFN
-// Return 0 if not legal SFN
-/////////////////////////////////////////////////////////////////////////////////
-static 
-int is_short( char* string, 
-              char* sfn_string)
-{
-    int s_size   = 0;
-    int dot_ext  = 0;       // dot offset in the filename
-    int name_len = 0;       // length of file name
-    int ext_len  = 0;       // length of extension
-    int i        = 0;
-    int sc_i     = 0;
-    char ch;
-
-    if(string[0] == '.' && string[1] == '\0')
-    {
-        sfn_string[0] = '.';
-        return 1;
-    }
-    if(string[0] == '.' && string[1] == '.' && string[2] == '\0')
-    {
-        sfn_string[0] = '.';
-        sfn_string[1] = '.';
-        return 1;
-    }
-    sfn_string[11] = '\0';
-    while (string[s_size] != '\0')
-    {
-        if (string[s_size] == '.')
-        {
-            dot_ext = s_size;
-            ext_len = -1;
-        }
-        ext_len++;
-        s_size++;
-    }
-    if (dot_ext != 0)
-    {
-        name_len = s_size - ext_len - 1;
-    }
-    else
-    {
-        name_len = s_size;
-        ext_len = 0;
-    }
-    if ( ext_len > 3 || ( name_len > 8))
-    {
-        return 0;
-    }
-    if (dot_ext != 0)
-    {
-        while (i != ext_len)
-        {
-            ch = to_upper(string[dot_ext + 1 + i]);
-            ch = illegal_short(ch);
-            sfn_string[8+i] = ch;
-            i++;
-        } 
-    }
-    i = 0;
-    sc_i = 0;
-    while (i!= name_len)
-    {
-        ch = to_upper(string[i]);
-        ch = illegal_short(ch);
-        if (ch != '.') sfn_string[sc_i++] = ch;
-        i++;
-    }
-    return 1;
-}
-
-///////////////////////////////////////////////////////////////////////
-// This function analyses the pathname argument, from the character 
-// defined by the *nb_read argument.
-// It copies the found name (between '/') in the name[] buffer, 
-// and updates the nb_read argument.
-// Return 1 if name found, Return 0 if NUL character found, 
-///////////////////////////////////////////////////////////////////////
-static 
-int get_name_from_path( char*          pathname,
-                        char*          name,
-                        unsigned int*  nb_read )	
-{
-    if ( pathname[*nb_read] == 0 ) return 0;
-
-    int i = (pathname[*nb_read] == '/')? (*nb_read) + 1 : *nb_read;
-    int j = 0;
+
+
+///////////////////////////////////////////////////////////////////////////
+static unsigned int _get_name_from_path( char*          pathname,  // input
+                                         char*          name,      // output
+                                         unsigned int*  nb_read )  // input & output	
+{
+    // skip leading "/" character
+    if ( pathname[*nb_read] == '/' ) *nb_read = *nb_read + 1;
+
+    // initialises current indexes
+    unsigned int i = *nb_read;
+    unsigned int j = 0;
    
-    while(pathname[i] != '/' && pathname[i] != '\0')
-    {
-        name[j] = pathname[i];    
-        j++;
-        i++;
-    }
+    while ( (pathname[i] != '/') && (pathname[i] != 0) )
+    {
+        name[j++] = pathname[i++];    
+        if ( j > NAME_MAX_SIZE ) return 1;
+    }
+
+    // set end of string
     name[j] = 0;
 
+    // skip trailing "/" character
     if ( pathname[i] == '/' ) *nb_read += j+1;
     else                      *nb_read += j;
 
-    return 1;
+    return 0;
 }
 
+
+
+////////////////////////////////////////////////////////////////////
+static unsigned int _get_last_name( char*   pathname,       // input
+                                    char*   name )          // output
+{
+    unsigned int nb_read = 0;      
+    while ( pathname[nb_read] != 0 )
+    {
+        if ( _get_name_from_path( pathname, name, &nb_read ) ) return 1;
+    }
+
+    return 0;
+}   // end _get_last_name()
+
+
+
 ////////////////////////////////////////////////////////////////////////////////
-static int get_name_from_short( char* dir_entry,     // input:  SFN dir_entry
-                                char* entry_name )   // output: name
+static void _get_name_from_short( unsigned char* buffer,  // input:  SFN dir_entry
+                                  char*          name )   // output: name
 {
     unsigned int i   = 0;
@@ -470,18 +763,16 @@
     while ( i < length )
     {
-        entry_name[i] = dir_entry[i];
+        name[i] = buffer[i];
         i++;
     }
-    entry_name[i] = '\0';
-
-    return i;
+    name[i] = 0;
 }
 
 ///////////////////////////////////////////////////////////////////////////////
-static int get_name_from_long( char *dir_entry,     // input : LFN dir_entry
-                               char *entry_name )   // output : name
-{
-    unsigned int   entry_name_offset   = 0;
-    unsigned int   dir_entry_offset    = get_length(LDIR_ORD);
+static void _get_name_from_long( unsigned char*  buffer, // input : LFN dir_entry
+                                 char*           name )  // output : name
+{
+    unsigned int   name_offset         = 0;
+    unsigned int   buffer_offset       = get_length(LDIR_ORD);
     unsigned int   l_name_1            = get_length(LDIR_NAME_1);
     unsigned int   l_name_2            = get_length(LDIR_NAME_2);
